# HG changeset patch
# User idxa
# Date 1382963025 -28800
#      Mon Oct 28 20:23:45 2013 +0800
# Node ID 12768418f3e2884a0fb181a4260260920141b742
# Parent  ef2428fd32feddd60168f3430c50f4d7e6f02741
1. modify rateTolerance from 0.1 to 1.0, in order to allow the final bitrate to fluctuate more(CBR to ABR)
2. ncu in initialization of ratecontrol is set according to 16x16 block size which is same to x264, for the empirical formula in x264 is for 16x16 size.
3. do more modification to make ratecontrol algorithm of x265 more similar to x264 for x264 has been developed for about 10 years and is very mature , it is reasonale to take its method firstly.

diff -r ef2428fd32fe -r 12768418f3e2 source/common/common.cpp
--- a/source/common/common.cpp	Mon Oct 28 00:08:06 2013 -0500
+++ b/source/common/common.cpp	Mon Oct 28 20:23:45 2013 +0800
@@ -186,8 +186,8 @@
 
     /* Rate control options */
     param->rc.bitrate = 0;
-    param->rc.rateTolerance = 0.1;
-    param->rc.qCompress = 0.6;
+	param->rc.rateTolerance = 1.0;
+	param->rc.qCompress = 0.6;
     param->rc.ipFactor = 1.4f;
     param->rc.pbFactor = 1.3f;
     param->rc.qpStep = 4;
diff -r ef2428fd32fe -r 12768418f3e2 source/encoder/ratecontrol.cpp
--- a/source/encoder/ratecontrol.cpp	Mon Oct 28 00:08:06 2013 -0500
+++ b/source/encoder/ratecontrol.cpp	Mon Oct 28 20:23:45 2013 +0800
@@ -131,7 +131,7 @@
     this->cfg = _cfg;
     bitrate = cfg->param.rc.bitrate * 1000;
     frameDuration = 1.0 / cfg->param.frameRate;
-    ncu = (int)((cfg->param.sourceHeight * cfg->param.sourceWidth) / pow((int)cfg->param.maxCUSize, 2.0));
+    ncu = (int)((cfg->param.sourceHeight * cfg->param.sourceWidth) / pow((int)16, 2.0));
     lastNonBPictType = -1;
     baseQp = cfg->param.rc.qp;
     qp = baseQp;
@@ -149,7 +149,7 @@
         accumPNorm = .01;
         accumPQp = (ABR_INIT_QP_MIN)*accumPNorm;
         /* estimated ratio that produces a reasonable QP for the first I-frame */
-        cplxrSum = .01 * pow(7.0e5, cfg->param.rc.qCompress) * pow(2 * ncu, 0.5);
+        cplxrSum = .01 * pow(7.0e5, cfg->param.rc.qCompress) * pow(ncu, 0.5);
         wantedBitsWindow = bitrate * frameDuration;
         lastNonBPictType = I_SLICE;
     }
@@ -260,7 +260,7 @@
     }
     else
     {
-        double abrBuffer = 1.5 * cfg->param.rc.rateTolerance * bitrate;
+		double abrBuffer = 2 * cfg->param.rc.rateTolerance * bitrate;
 
         /* 1pass ABR */
 
@@ -306,46 +306,30 @@
             q = qp2qScale(accumPQp / accumPNorm);
             q /= fabs(cfg->param.rc.ipFactor);
         }
-        if (cfg->param.rc.rateControlMode != X265_RC_CRF)
-        {
-            double lqmin = 0, lqmax = 0;
+		else if (framesDone>0)
+		{
+			 if (cfg->param.rc.rateControlMode != X265_RC_CRF)
+			 {
+				double lqmin = 0, lqmax = 0;
+				if (totalBits == 0)
+				{
+					lqmin = qp2qScale(ABR_INIT_QP_MIN) / lstep;
+					lqmax = qp2qScale(ABR_INIT_QP_MAX) * lstep;
+				}
+				else
+				{
+					lqmin = lastQScaleFor[sliceType] / lstep;
+					lqmax = lastQScaleFor[sliceType] * lstep;
+				}
 
-            /* Clip the qp of 1st 'N' frames running parallely to ensure it doesnt detoriate
-             * the quality */
-            if (totalBits == 0)
-            {
-                lqmin = qp2qScale(ABR_INIT_QP_MIN) / lstep;
-                lqmax = qp2qScale(ABR_INIT_QP_MAX) * lstep;
-            }
+				if (overflow > 1.1 && framesDone > 3)
+					lqmax *= lstep;
+				else if (overflow <0.9)
+					lqmin /= lstep;
 
-            /* Asymmetric clipping, because symmetric would prevent
-             * overflow control in areas of rapidly oscillating complexity */
-            else
-            {
-                lqmin = lastQScaleFor[sliceType] / lstep;
-                lqmax = lastQScaleFor[sliceType] * lstep;
-            }
-
-            /* Rate control needs to be more aggressive based on actual costs obtained for
-             * previous encoded frame */
-            int rfAdapt = 1;
-            if (overflow > 1.1 && framesDone > 3)
-            {
-                /* Control propagation of excessive overflow / underfow */
-                if (overflow > 1.5)
-                    rfAdapt = 2;
-                lqmax *= pow(lstep, rfAdapt);
-                lqmin /= pow(lstep, rfAdapt / cfg->param.frameNumThreads);
-            }
-            else if (overflow < 0.9)
-            {
-                if (overflow < 0.6)
-                    rfAdapt = 2;
-                lqmin /= pow(lstep, rfAdapt);
-                lqmax /= pow(lstep, rfAdapt / cfg->param.frameNumThreads);
-            }
-            q = Clip3(lqmin, lqmax, q);
-        }
+				q = Clip3(lqmin, lqmax, q);
+			 }
+		}
 
         double lmin1 = lmin[sliceType];
         double lmax1 = lmax[sliceType];
@@ -385,7 +369,7 @@
         if (rce->sliceType != B_SLICE)
             /* The factor 1.5 is to tune up the actual bits, otherwise the cplxrSum is scaled too low
              * to improve short term compensation for next frame. */
-            cplxrSum += 1.5 * bits * qp2qScale(rce->qpaRc) / rce->qRceq;
+            cplxrSum += bits * qp2qScale(rce->qpaRc) / rce->qRceq;
         else
         {
             /* Depends on the fact that B-frame's QP is an offset from the following P-frame's.
